unit Unit1;

// Exemple de contrle du bureau

// La mise  jour du bureau ne doit pas se faire
// trop rapidement except peut-tre en mode
// Active Desktop (W98+).

// Il existe des dizaines d'autres fonctions
// que celles prsentes dans cet exemple.
// Pour toutes les voir, tapez ListView_ puis
// Ctrl+Espace.
// Attentions certaines fonctions provoquent
// un crash de explorer.exe. Je pense qu'il
// n'y a pas d'incidence. Il se relance aussitt.

// Rmi GILLIG | http://remigillig.free.fr | remigillig@free.fr

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, CommCtrl;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    ComboBox1: TComboBox;
    Button4: TButton;
    procedure GetBureauLV;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button4Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;
  BureauLV: integer;
  ItemPos: TPoint;
  clrText: TColorRef;
  cltBkText :TColorRef;
implementation

{$R *.DFM}

procedure TForm1.GetBureauLV;
begin
  BureauLV := FindWindow('ProgMan', nil);
  BureauLV := FindWindowEx(BureauLV, 0, 'ShellDLL_DefView', nil);
  BureauLV := FindWindowEx(BureauLV, 0, 'SysListView32', nil);
  if BureauLV = 0 then // Si BureauLV est gal 0, le handle n'a pas pu tre rcupr
    Application.MessageBox('Erreur', 'Erreur', 16);
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  ListView_SetTextColor(BureauLV, RGB(255, 255, 0)); // On change la couleur du texte
  // $FFFFFFFF signifie aucune couleur
  ListView_SetTextBkColor(BureauLV, $FFFFFFFF);
  Button2.Click; // Un clic sur le bouton 2 pour mettre  jour le bureau
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  // Pour redessiner toutes les icnes avec les nouveaux paramtres
  SendMessage(BureauLV, WM_ERASEBKGND, GetDC(BureauLV), 0);
  SendMessage(BureauLV, WM_PAINT, GetDC(BureauLV), 0);
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  // On modifie la position de l'icne slectionne
  ListView_SetItemPosition(BureauLV, ComboBox1.ItemIndex+1, Mouse.CursorPos.x, Mouse.CursorPos.y);
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  i, ItemCount: integer;
begin
  GetBureauLV;
  Form1.Caption := IntToStr(BureauLV); // On affiche le Handle du bureau
  ItemCount := ListView_GetItemCount(BureauLV); // On rcupre le nombre d'icnes
  for i := 1 to ItemCount do // On fait une liste des icnes
    begin
    ComboBox1.Items.Add(IntToStr(i));
    end;
  clrText:=ListView_GetTextColor(BureauLV);
  cltBkText:=GetBkColor(BureauLV);
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  ListView_SetTextColor(BureauLV, clrText); // On change la couleur du texte
  // $FFFFFFFF signifie aucune couleur
  ListView_SetTextBkColor(BureauLV, cltBkText);
  Button2.Click; // Un clic sur le bouton 2 pour mettre  jour le bureau
end;

end.
 